
import socket
import numarray as na
import struct
import common

class FTCommands:
    def __init__(self):
        """ constructor, setting initial variables """
	self.dither_freq = 29.257127
	self.dither_amp = 10.5
	self.opdamp = 13.2
	self.dither_smoothfrac = 0.05
        self.dither_delay = 0.0
	self.active=[0,0,0,0,0,0]
	self.offset=[0.0,0.0,0.0,0.0,0.0,0.0]
	self.gain=[1,1,1,1,1,1]
	self.search_state=[0,0,0,0,0,0]
        self.search_step=[0.0,0.0,0.0,0.0,0.0,0.0]
 	self.search_threshold=[1000.,1000.,1000.,1000.,1000.,1000.]
        self.opdmapsfile = 'jdm_opds30Hz.txt'
    def initSocket(self):
        self.sock = None
        for res in socket.getaddrinfo(common.host, common.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'
            

    def updateFTStructure(self):
        self.initSocket()
        c_struct = struct.pack(
            '5f6i6f6f6i6f6f20s',
	    self.dither_freq,
	    self.dither_amp,
	    self.opdamp,
	    self.dither_smoothfrac,
            self.dither_delay,
	    self.active[0], self.active[1], self.active[2], 
	    self.active[3], self.active[4], self.active[5],
	    self.offset[0], self.offset[1], self.offset[2], 
	    self.offset[3], self.offset[4], self.offset[5],
	    self.gain[0], self.gain[1], self.gain[2], 
	    self.gain[3], self.gain[4], self.gain[5],
	    self.search_state[0],self.search_state[1],self.search_state[2],
            self.search_state[3],self.search_state[4],self.search_state[5],
	    self.search_step[0], self.search_step[1], self.search_step[2],
            self.search_step[3], self.search_step[4], self.search_step[5],
            self.search_threshold[0],self.search_threshold[1], self.search_threshold[2],
            self.search_threshold[3],self.search_threshold[4], self.search_threshold[5],
            self.opdmapsfile
            )
        
        strLen = len(c_struct)
        print strLen
        self.sock.send('FT')
        print "sent FT"
        self.sock.send(struct.pack('L',strLen))
	print "sent ", strLen
        self.sock.send(c_struct)
        data = self.sock.recv(2)
        self.sock.close()
        print 'Received', repr(data)



        
